class Checkbox
{
  PVector _p1; // starting point
  PVector _p2; // end point

  int     _h = 10; // height of checkbox
  int     _w = 20; // width of checkbox
  boolean    _checked = false; // flag checkbox selected

  // x/y of scheckbox, width/height of bg checkbox
  Checkbox(int x,int y, boolean preselected)
  {
    //_dir = dir;
    _p1 = new PVector(x+_w*.5, y);
    _p2 = new PVector(x+_w*.5, y+_h);
    
    if (preselected==true) _checked=true; 
    
    smooth(); // svg loaded for slider styling
  }

  boolean isHit(int x,int y)
  {
    if (x > _p1.x - 10 && x < _p1.x + 10 &&
      y > _p1.y && y < _p2.y) {
      return true;
    } 
    else {
      return false;
    }
  }

  void draw()
  {
    pushStyle();
      drawCheckbox();
      if (_checked==true) drawKnob(false); // if preselected
    popStyle();
  }

  void drawCheckbox()
  {
    PShape checkboxBg = loadShape("checkbox_bg.svg");
    PShape checkboxEnd = loadShape("checkbox_end.svg");

    checkboxBg.rotate(radians(-90));
    checkboxEnd.rotate(radians(-90));
    shape(checkboxEnd,_p1.x-_w/1.5*.5,_p1.y+10/1.5,20/1.5,20/1.5); // end left
    shape(checkboxEnd,_p1.x-_w/1.5*.5,_p2.y+10/1.5,20/1.5,20/1.5); // end right
    shape(checkboxBg,_p1.x-_w/1.5*.5,_p2.y,_w/1.5,_h); // strip
  }

  void drawKnob(boolean hover)
  {
    PShape sliderKnob = null;
    if (hover==false) {
      sliderKnob = loadShape("checkbox_knob.svg");
    } else {
      sliderKnob = loadShape("checkbox_knob_hover.svg");
    }
    
    PVector dir = PVector.sub(_p1,_p2);
    PVector pos = PVector.add( _p2, PVector.mult(dir,0.5));
    shape(sliderKnob,pos.x-_w*.5, pos.y - 10,20,20);
  }

  void mousePos(int x,int y,boolean pressed)
  {
    if(pressed)
    {
      if(isHit(x,y))
      {
        if (_checked==false) {
          drawKnob(false); // checkbox activated
          _checked = true;
        } else {
          _checked = false;
        }
      }
    }
    else
    {  // mouse over: highlight knob, only if knob visible
      if(isHit(x,y) && _checked==true) drawKnob(true);
    }
  }
}

